#include <hmg.ch>

PROCEDURE c_browse

   SET century on
   SET date german
   SET interactiveclose on
   SET multiple off warning
   SET navigation extended
   SET tooltipbackcolor { 193, 224, 255}
   SET tooltipstyle balloon
   SET decimals to  0

   DEFINE WINDOW win_browse ;
      AT 10, 10  ;
      WIDTH  600 ; 
      HEIGHT 600 ; 
      TITLE "browse definition" ;
      MODAL 

      ON KEY ESCAPE ACTION win_browse.Release

          @ 053, 050 LABEL    browse_1x WIDTH 500   HEIGHT 30  VALUE 'mBrowse('         FONT "Arial" SIZE 14  BOLD
          @ 053, 145 LABEL    browse_2x WIDTH 500   HEIGHT 30  VALUE '025,030,650,450,' FONT "Arial" SIZE 14  BOLD FONTCOLOR RED
          @ 053, 291 LABEL    browse_3x WIDTH 500   HEIGHT 30  VALUE 'Browse_'          FONT "Arial" SIZE 14  BOLD 
          @ 053, 366 LABEL    browse_4x WIDTH 500   HEIGHT 30  VALUE '3,STOCK,Form_1'   FONT "Arial" SIZE 14  BOLD FONTCOLOR RED
          @ 053, 520 LABEL    browse_5x WIDTH 050   HEIGHT 30  VALUE ')'                FONT "Arial" SIZE 14  BOLD 
  
          @ 110, 130 LABEL    browse_2 WIDTH 110   HEIGHT 30  VALUE "ROW" FONT "Arial" SIZE 12  BOLD
          @ 110, 290 TEXTBOX  browse_3 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 150, 131 LABEL    browse_4 WIDTH 110   HEIGHT 30  VALUE "COL" FONT "Arial" SIZE 12  BOLD
          @ 150, 290 TEXTBOX  browse_5 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 191, 130 LABEL    browse_6 WIDTH 110   HEIGHT 30  VALUE "WIDTH" FONT "Arial" SIZE 12  BOLD
          @ 190, 290 TEXTBOX  browse_7 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 231, 130 LABEL    browse_8 WIDTH 110   HEIGHT 30  VALUE "HEIGHT" FONT "Arial" SIZE 12  BOLD
          @ 230, 290 TEXTBOX  browse_9 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 271, 130 LABEL    browse_10 WIDTH 110   HEIGHT 30  VALUE "Browse_" FONT "Arial" SIZE 12  BOLD
          @ 270, 290 TEXTBOX  browse_11 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 311, 130 LABEL    browse_12 WIDTH 110   HEIGHT 30  VALUE "DataBase" FONT "Arial" SIZE 12  BOLD
          @ 310, 290 TEXTBOX  browse_13 WIDTH 110   HEIGHT 25  VALUE " " FONT "Arial" SIZE 11  BOLD UPPERCASE 

          @ 351, 130 LABEL    browse_14 WIDTH 110   HEIGHT 30  VALUE "WindowName" FONT "Arial" SIZE 12  BOLD
          @ 350, 290 TEXTBOX  browse_15 WIDTH 110   HEIGHT 25  VALUE " " FONT "Arial" SIZE 11  BOLD UPPERCASE 
     
          @ 391, 130 LABEL    browse_16 WIDTH 140   HEIGHT 30  VALUE "Up-Down Buttons" FONT "Arial" SIZE 12  BOLD
          @ 390, 290 CHECKBOX browse_17 CAPTION ''  VALUE .T. 

          @ 431, 130 LABEL    browse_18 WIDTH 120   HEIGHT 30  VALUE "Color_Browse" FONT "Arial" SIZE 12  BOLD
          @ 430, 290 CHECKBOX browse_19 CAPTION ''  VALUE .T. 
         

          @ 500, 175 BUTTON browse_button ;
          CAPTION "OK" ;
          ACTION create_browse() ;
          WIDTH 100 ;
          HEIGHT 30 

          @ 500, 350 BUTTON button_mbroexit ;
          CAPTION "CANCEL" ;
          ACTION win_browse.Release  ;
          WIDTH 100 ;
          HEIGHT 30 


   END WINDOW

   win_browse.browse_3.setfocus

   CENTER WINDOW win_browse
   ACTIVATE WINDOW win_browse

RETURN

*:----------------------------------------------------------------*
PROCEDURE create_browse

 Local _result := '',  _crlf := chr(13)+chr(10)

 Local  DNomZ       := ALLTRIM(STR(win_browse.browse_11.value))
 Local  DCurZRow    := ALLTRIM(STR(win_browse.browse_3.value))   
 Local  DCurZCol    := ALLTRIM(STR(win_browse.browse_5.value))
 Local  DLasZWidth  := ALLTRIM(STR(win_browse.browse_7.value))

 Local  mAurZCol1   :=((win_browse.browse_7.value)/2 ) -125    
 Local  mDurZCol2   := mAurZCol1 + 150 

 Local  mCurZCol1   :=((win_browse.browse_7.value)/2 )-56
 Local  mCurZCol2   := mCurZCol1 + 27
 Local  mCurZCol3   := mCurZCol1 + 55
 Local  mCurZCol4   := mCurZCol1 + 82

 Local  DLasZHeight := ALLTRIM(STR(win_browse.browse_9.value))
 Local  NumyZHeight := (win_browse.browse_9.value) + 85 
 Local  NumyZComant := (win_browse.browse_9.value) + 45   
 Local  mTable      := ALLTRIM(win_browse.browse_13.value)
 Local  wName       := CamelCase( ALLTRIM( LOWER( win_browse.browse_15.value) ) ,.T.,{"/","\"}) 

*-----------------------------------------------------------------*

 IF win_browse.browse_13.value  <= SPACE(1)
    MsgStop("Missing DataBase","Attention")
    win_browse.browse_13.setfocus
    Return 
 ENDIF

 IF win_browse.browse_15.value  <= SPACE(1)
    MsgStop("Missing <WindowName>","Attention")
    win_browse.browse_15.setfocus
    Return 
 ENDIF
*-----------------------------------------------------------------*
 _result += '*--------------------------------------------------------------------------------* ' + _crlf
*-----------------------------------------------------------------*
 IF win_browse.browse_19.Value = .T.
 _result += ' PRIVATE bColor := { || IF ( ordkeyno()/2 == INT(ordkeyno()/2) , { 254,254,228 } , { 180,200,255 } ) } ' + _crlf 
 _result += ' PRIVATE fColor := { || IF ( ordkeyno()/2 == INT(ordkeyno()/2) , { 006,120,006 } , { 000,000,255 } ) } ' + _crlf 	
 _result += ' PRIVATE nCount , xnCount , xbColor , xfColor                                      ' + _crlf
 _result += ' PRIVATE ficher , aFieldNames ,aHeaders , aWidths , i                              ' + _crlf      
 _result += '*--------------------------------------------------------------------------------* ' + _crlf
ENDIF
*---------------------------------------------------------------------------------------------*
 _result += '  ficher      := "' + mTable +'"                                                   ' + _crlf   
 _result += '  aFieldNames := {}                                                                ' + _crlf  
 _result += '  aHeaders    := {}                                                                ' + _crlf  
 _result += '  aWidths     := {}                                                                ' + _crlf  
 _result += '                                                                                   ' + _crlf
 _result += ' USE '+ mTable                                                                       + _crlf  
 _result += ' PACK                                                                              ' + _crlf
 IF win_browse.browse_19.Value = .T.
 _result += '*--------------------------------------------------------------------------------* ' + _crlf
 _result += ' nCount  := ' +  mTable + '->( FCOUNT() )                                          ' + _crlf   
 _result += ' xnCount := nCount -1                                                              ' + _crlf 
 _result += ' xbColor := "{ " + REPLICATE(  ALLTRIM("bColor,") , xnCount ) + ALLTRIM("bColor") +" }" ' + _crlf    
 _result += ' xfColor := "{ " + REPLICATE(  ALLTRIM("fColor,") , xnCount ) + ALLTRIM("fColor") +" }" ' + _crlf    
 _result += '*--------------------------------------------------------------------------------* ' + _crlf
ENDIF
 _result += ' For i := 1 To FCount()                                                            ' + _crlf
 _result += '     aadd ( aFieldNames , ficher + "->"+ FieldName(i) )                            ' + _crlf
 _result += '     aadd ( aHeaders , FieldName(i) )                                              ' + _crlf
 _result += '     aadd ( aWidths , 160 )                                                        ' + _crlf
 _result += ' Next i                                                                            ' + _crlf
 _result += '*---------------------------------  Browse --------------------------------------* ' + _crlf
 _result += ' USE '+ mTable                                                                       + _crlf
 _result += '                                                                                   ' + _crlf
 _result += ' DEFINE BROWSE Browse_' + DNomZ                                                      + _crlf       
 _result += '        ROW     ' +  DCurZRow                                                        + _crlf         
 _result += '        COL     ' +  DCurZCol                                                        + _crlf
 _result += '        WIDTH   ' +  DLasZWidth                                                      + _crlf
 _result += '        HEIGHT  ' +  DLasZHeight                                                     + _crlf
 _result += '        VALUE 0                                                                    ' + _crlf
 _result += '        HEADERS  aHeaders                                                          ' + _crlf
 _result += '        WIDTHS   aWidths                                                           ' + _crlf
 _result += '        WORKAREA &(ficher)                                                         ' + _crlf
 _result += '        FIELDS + aFieldNames                                                       ' + _crlf
 _result += '        FONTNAME "Arial"                                                           ' + _crlf
 _result += '        FONTSIZE 9                                                                 ' + _crlf
 _result += '        TOOLTIP ""                                                                 ' + _crlf
 _result += '        ONCHANGE Nil                                                               ' + _crlf
 _result += '        ONGOTFOCUS Nil                                                             ' + _crlf
 _result += '        ONLOSTFOCUS Nil                                                            ' + _crlf
 _result += '        FONTBOLD .F.                                                               ' + _crlf
 _result += '        FONTITALIC .F.                                                             ' + _crlf
 _result += '        FONTUNDERLINE .F.                                                          ' + _crlf
 _result += '        FONTSTRIKEOUT .F.                                                          ' + _crlf
 _result += '        ONDBLCLICK Nil                                                             ' + _crlf
 _result += '        ALLOWEDIT .T.                                                              ' + _crlf
 _result += '        ALLOWAPPEND .T.                                                            ' + _crlf
 _result += '        ONHEADCLICK Nil                                                            ' + _crlf
 _result += '        ALLOWDELETE .T.                                                            ' + _crlf
 _result += '        HELPID Nil                                                                 ' + _crlf
 _result += '        VALID Nil                                                                  ' + _crlf
 _result += '        VALIDMESSAGES Nil                                                          ' + _crlf
 _result += '        LOCK .T.                                                                   ' + _crlf
 _result += '        VSCROLLBAR .F.                                                             ' + _crlf
*---------------------------------------------------------------------------------------------* 
 IF win_browse.browse_19.Value = .T.
 _result += '        DYNAMICBACKCOLOR &(xbColor)                                                ' + _crlf
 _result += '        DYNAMICFORECOLOR &(xfColor)                                                ' + _crlf
 _result += '        BACKCOLOR { 180,200,255 }                                                  ' + _crlf
 _result += '        FONTCOLOR Nil                                                              ' + _crlf
ELSE
 _result += '        DYNAMICBACKCOLOR Nil                                                       ' + _crlf
 _result += '        DYNAMICFORECOLOR Nil                                                       ' + _crlf
 _result += '        BACKCOLOR Nil                                                              ' + _crlf
 _result += '        FONTCOLOR Nil                                                              ' + _crlf
ENDIF 
*---------------------------------------------------------------------------------------------* 
 _result += '        INPUTMASK Nil                                                              ' + _crlf
 _result += '        FORMAT Nil                                                                 ' + _crlf
 _result += '        WHEN Nil                                                                   ' + _crlf
 _result += '        INPUTITEMS Nil                                                             ' + _crlf
 _result += '        DISPLAYITEMS Nil                                                           ' + _crlf
 _result += '        IMAGE Nil                                                                  ' + _crlf
 _result += '        JUSTIFY Nil                                                                ' + _crlf
 _result += '        NOLINES .F.                                                                ' + _crlf
 _result += '        READONLYFIELDS Nil                                                         ' + _crlf
 _result += '        HEADERIMAGES Nil                                                           ' + _crlf
 _result += ' END BROWSE                                                                        ' + _crlf
 _result += '                                                                                   ' + _crlf
 _result += '*------------------------------- End  Browse ------------------------------------* ' + _crlf
 _result += '                                                                                   ' + _crlf
 _result += '    DEFINE BUTTON But_01                                 ' + _crlf                
 _result += '           ROW    ' + ALLTRIM(STR(NumyZComant))            + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mAurZCol1 ))             + _crlf   
 _result += '           WIDTH  130                                    ' + _crlf
 _result += '           HEIGHT 028                                    ' + _crlf
 _result += '           CAPTION "Append Record"                       ' + _crlf
 _result += '           PICTURE ""                                    ' + _crlf  
 _result += '           TOOLTIP "Append"                              ' + _crlf
 _result += '           ACTION ( '+ mTable +'->( DbGoBottom() ) , '+ mTable +'->( DbAppend() ) , '+ wName + '.Browse_'+ DNomZ+ '.Refresh ) ' + _crlf  
 _result += '    END BUTTON                                           ' + _crlf
 _result += '                                                         ' + _crlf

 _result += '    DEFINE BUTTON But_02                                 ' + _crlf                
 _result += '           ROW    ' + ALLTRIM(STR(NumyZComant))            + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mDurZCol2 ))             + _crlf   
 _result += '           WIDTH  130                                    ' + _crlf
 _result += '           HEIGHT 028                                    ' + _crlf
 _result += '           CAPTION "Delete Record"                       ' + _crlf
 _result += '           PICTURE ""                                    ' + _crlf  
 _result += '           TOOLTIP "Delete"                              ' + _crlf
 _result += '           ACTION ( '+ mTable +'->( DbDelete() ) , '+ wName + '.Browse_'+ DNomZ+ '.Refresh ) ' + _crlf  
 _result += '    END BUTTON                                          ' + _crlf
 _result += '                                                        ' + _crlf
 _result += '*--------------------------------------------------------------------------------* ' + _crlf
*------------------------------------------ Buttons Up-Down ----------------------------------*
_result += '                                                         ' + _crlf
IF win_browse.browse_17.Value = .T.
 _result += '    DEFINE BUTTON But_03                                ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight))           + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mCurZCol1) )            + _crlf  
 _result += '           WIDTH  028                                   ' + _crlf
 _result += '           HEIGHT 028                                   ' + _crlf
 _result += '           CAPTION "<<"                                 ' + _crlf
 _result += '           PICTURE ""                                   ' + _crlf  
 _result += '           TOOLTIP "First"                              ' + _crlf
 _result += '           ACTION ( dBGoTop() , '+ wName + '.Browse_'+ DNomZ+'.Value := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                                          ' + _crlf

 _result += '                                                        ' + _crlf
 _result += '    DEFINE BUTTON But_04                                ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight))           + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mCurZCol2))             + _crlf  
 _result += '           WIDTH  028                                   ' + _crlf
 _result += '           HEIGHT 028                                   ' + _crlf
 _result += '           CAPTION "<"                                  ' + _crlf
 _result += '           PICTURE ""                                   ' + _crlf  
 _result += '           TOOLTIP "Previous"                           ' + _crlf
 _result += '           ACTION ( dBSkip ( -1 ) , '+ wName + '.Browse_'+ DNomZ+'.Value:= '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                                          ' + _crlf
 _result += '                                                        ' + _crlf

 _result += '    DEFINE BUTTON But_05                                ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight))           + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mCurZCol3))             + _crlf   
 _result += '           WIDTH  028                                   ' + _crlf
 _result += '           HEIGHT 028                                   ' + _crlf
 _result += '           CAPTION ">"                                  ' + _crlf
 _result += '           PICTURE ""                                   ' + _crlf  
 _result += '           TOOLTIP "Next"                               ' + _crlf
 _result += '           ACTION ( dBSkip (1) , if ( Eof() , DbGoBottom() , Nil ) ,'+ wName + '.Browse_'+ DNomZ+'.Value := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                                          ' + _crlf
 _result += '                                                        ' + _crlf

 _result += '    DEFINE BUTTON But_06                                ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight))           + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mCurZCol4))             + _crlf   
 _result += '           WIDTH  028                                   ' + _crlf
 _result += '           HEIGHT 028                                   ' + _crlf
 _result += '           CAPTION ">>"                                 ' + _crlf
 _result += '           PICTURE ""                                   ' + _crlf  
 _result += '           TOOLTIP "Lastt"                              ' + _crlf
 _result += '           ACTION  ( dBGoBottom() , '+ wName + '.Browse_'+ DNomZ+'.Value := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                                          ' + _crlf
 _result += '                                                        ' + _crlf
ENDIF
 _result += '*--------------------------------------------------- Box  Grid -------------------------------------------*  ' + _crlf
 _result += '    HMG_ChangeWindowStyle ( GetControlHandle("Browse_' + DNomZ +'","'+ wName +'") , LVS_REPORT, NIL, .T. )   ' + _crlf 
 _result += '*---------------------------------------------------------------------------------------------------------*  ' + _crlf

 System.Clipboard := _result
 
 msginfo(_result)

Return  Nil 

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
