#include <hmg.ch>

PROCEDURE c_grid

   SET century on
   SET date german
   SET interactiveclose on
   SET multiple off warning
   SET navigation extended
   SET tooltipbackcolor { 193, 224, 255}
   SET tooltipstyle balloon
   SET decimals to  0

   DEFINE WINDOW win_grid ;
      AT 10, 10  ;
      WIDTH  600 ; 
      HEIGHT 600 ; 
      TITLE "grid definition" ;
      MODAL 

      ON KEY ESCAPE ACTION win_grid.Release

          @ 053, 077 LABEL    Grid_1x WIDTH 500   HEIGHT 30  VALUE 'mGrid('           FONT "Arial" SIZE 14  BOLD
          @ 053, 145 LABEL    Grid_2x WIDTH 500   HEIGHT 30  VALUE '025,030,650,450,' FONT "Arial" SIZE 14  BOLD FONTCOLOR RED
          @ 053, 291 LABEL    Grid_3x WIDTH 500   HEIGHT 30  VALUE 'Grid_'            FONT "Arial" SIZE 14  BOLD 
          @ 053, 343 LABEL    Grid_4x WIDTH 500   HEIGHT 30  VALUE '3,STOCK,Form_1'   FONT "Arial" SIZE 14  BOLD FONTCOLOR RED
          @ 053, 501 LABEL    Grid_5x WIDTH 025   HEIGHT 30  VALUE ')'                FONT "Arial" SIZE 14  BOLD 
  
          @ 110, 130 LABEL    grid_2 WIDTH 110   HEIGHT 30  VALUE "ROW" FONT "Arial" SIZE 12  BOLD
          @ 110, 290 TEXTBOX  grid_3 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 150, 131 LABEL    grid_4 WIDTH 110   HEIGHT 30  VALUE "COL" FONT "Arial" SIZE 12  BOLD
          @ 150, 290 TEXTBOX  grid_5 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 191, 130 LABEL    grid_6 WIDTH 110   HEIGHT 30  VALUE "WIDTH" FONT "Arial" SIZE 12  BOLD
          @ 190, 290 TEXTBOX  grid_7 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 231, 130 LABEL    grid_8 WIDTH 110   HEIGHT 30  VALUE "HEIGHT" FONT "Arial" SIZE 12  BOLD
          @ 230, 290 TEXTBOX  grid_9 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 271, 130 LABEL    grid_10 WIDTH 110   HEIGHT 30  VALUE "Grid_" FONT "Arial" SIZE 12  BOLD
          @ 270, 290 TEXTBOX  grid_11 WIDTH 070   HEIGHT 25  VALUE 0 FONT "Arial" SIZE 11  BOLD NUMERIC INPUTMASK '9999'  

          @ 311, 130 LABEL    grid_12 WIDTH 110   HEIGHT 30  VALUE "DataBase" FONT "Arial" SIZE 12  BOLD
          @ 310, 290 TEXTBOX  grid_13 WIDTH 110   HEIGHT 25  VALUE " " FONT "Arial" SIZE 11  BOLD UPPERCASE 

          @ 351, 130 LABEL    grid_14 WIDTH 110   HEIGHT 30  VALUE "WindowName" FONT "Arial" SIZE 12  BOLD
          @ 350, 290 TEXTBOX  grid_15 WIDTH 110   HEIGHT 25  VALUE " " FONT "Arial" SIZE 11  BOLD UPPERCASE 

          @ 391, 130 LABEL    grid_16 WIDTH 140   HEIGHT 30  VALUE "Up-Down Buttons" FONT "Arial" SIZE 12  BOLD     
          @ 390, 290 CHECKBOX grid_17 CAPTION ''  VALUE .T. 
         
          @ 431, 130 LABEL    grid_18 WIDTH 120   HEIGHT 30  VALUE "Color_Grid" FONT "Arial" SIZE 12  BOLD
          @ 430, 290 CHECKBOX grid_19 CAPTION ''  VALUE .T. 
 
          @ 468, 065 LABEL   grid_20 WIDTH 500 HEIGHT 30    VALUE "Very Important to Include in Main ->   #include <dbstruct.ch>" ;
                                      FONT "Arial" SIZE 12  BOLD  FONTCOLOR RED
        
          @ 500, 175 BUTTON grid_button ;
          CAPTION "OK" ;
          ACTION create_grid() ;
          WIDTH 100 ;
          HEIGHT 30 

          @ 500, 350 BUTTON button_mgriexit ;
          CAPTION "CANCEL" ;
          ACTION win_grid.Release  ;
          WIDTH 100 ;
          HEIGHT 30 

   END WINDOW

   win_grid.grid_3.setfocus

   CENTER WINDOW win_grid
   ACTIVATE WINDOW win_grid

RETURN

*:-------------------------------------------------------------*
PROCEDURE create_grid

 Local _result := '',  _crlf := chr(13)+chr(10)

 Local  DNomZ       := ALLTRIM(STR(win_grid.grid_11.value))
 Local  DCurZRow    := ALLTRIM(STR(win_grid.grid_3.value))   
 Local  DCurZCol    := ALLTRIM(STR(win_grid.grid_5.value))
 Local  DLasZWidth  := ALLTRIM(STR(win_grid.grid_7.value))
 Local  mCurZCol1   := ((win_grid.grid_7.value)/2 )-56
 Local  mCurZCol2   := mCurZCol1 + 27
 Local  mCurZCol3   := mCurZCol1 + 55
 Local  mCurZCol4   := mCurZCol1 + 82
 Local  DLasZHeight := ALLTRIM(STR(win_grid.grid_9.value))
 Local  NumyZHeight := (win_grid.grid_9.value) + 85   
 Local  NumyZComant := (win_grid.grid_9.value) + 45   
 Local  mTable      := ALLTRIM(win_grid.grid_13.value)
 Local  wName       := CamelCase( ALLTRIM( LOWER( win_grid.grid_15.value) ) ,.T.,{"/","\"}) 
*----------------------------------------------------------------*

 IF win_grid.grid_13.value  <= SPACE(1)
    MsgStop("Missing DataBase","Attention")
    win_grid.grid_13.setfocus
    Return 
 ENDIF

 IF win_grid.grid_15.value  <= SPACE(1)
    MsgStop("Missing <WindowName>","Attention")
    win_grid.grid_15.setfocus
    Return 
 ENDIF

*-----------------------------------------------------------------*
 _result += '*------------------------------- Color  Grid --------------------------------------* ' + _crlf
*-----------------------------------------------------------------------------------------------*
 _result += ' PUBLIC aCpos1 := {} ; aCpos2 := {} ; aTips := {} ; aLong := {} ; aDec := {}         ' + _crlf
 _result += ' PUBLIC nCpos , aColCtrls := {}                                                      ' + _crlf
 IF win_grid.grid_19.Value = .T.
 _result += ' PRIVATE bColor := { || IIF( This.CellRowIndex/2 == INT(This.CellRowIndex/2),{252,200,146},{242,220,238} ) } ' + _crlf 
 _result += ' PRIVATE fColor := { || IF ( recno()/2 == int(recno()/2) , { 000,255,020 } , { 015,000,255 } ) }             ' + _crlf 
 _result += ' PRIVATE nCount , xnCount , xbColor , xfColor                                        ' + _crlf
 _result += ' PRIVATE ficher , aFieldNames ,aHeaders , aWidths , i                                ' + _crlf      
 _result += '*----------------------------------------------------------------------------------* ' + _crlf
 _result += ' _HMG_SYSDATA [ 348 ] := { 199,250,225 }                                             ' + _crlf
 _result += ' _HMG_SYSDATA [ 349 ] := { 007,071,041 }                                             ' + _crlf
 _result += ' _HMG_SYSDATA [ 350 ] := { 235,237,095 }                                             ' + _crlf
 _result += ' _HMG_SYSDATA [ 351 ] := { 069,015,135 }                                             ' + _crlf
 _result += '*----------------------------------------------------------------------------------* ' + _crlf   
ENDIF
*-----------------------------------------------------------------------------------------------*
 _result += '*----------------------------------  Grid -----------------------------------------* ' + _crlf
 _result += ' PRIVATE mAlias     := ""                                                            ' + _crlf
 _result += ' PRIVATE aFldnm     := {}                                                            ' + _crlf                    
 _result += ' PRIVATE aWidth     := {}                                                            ' + _crlf             
 _result += ' PRIVATE aStruct    := {}                                                            ' + _crlf             
 _result += '*----------------------------------------------------------------------------------* ' + _crlf
 _result += '*----------------------------------------------------------------------------------* ' + _crlf
 _result += ' USE '+ mTable                                                                         + _crlf
 _result += ' PACK                                                                                ' + _crlf
IF win_grid.grid_19.Value = .T.
 _result += '*----------------------------------------------------------------------------------* ' + _crlf
 _result += ' nCount  := ' +  mTable + '->( FCOUNT() )                                            ' + _crlf   
 _result += ' xnCount := nCount -1                                                                ' + _crlf 
 _result += ' xbColor := "{ " + REPLICATE(  ALLTRIM("bColor,") , xnCount ) + ALLTRIM("bColor") +" }" ' + _crlf    
 _result += ' xfColor := "{ " + REPLICATE(  ALLTRIM("fColor,") , xnCount ) + ALLTRIM("fColor") +" }" ' + _crlf    
 _result += '*----------------------------------------------------------------------------------* ' + _crlf
ENDIF
 _result += ' mAlias  := alias()                      ' + _crlf
 _result += ' aStruct := dbstruct()                   ' + _crlf
 _result += '                                         ' + _crlf
 _result += ' For i = 1 to  LEN(aStruct)              ' + _crlf
 _result += '     aadd(aFldnm, aStruct[i, 1])         ' + _crlf
 _result += '     aadd(aWidth, aStruct[i, 3]*10)      ' + _crlf
 _result += ' Next                                    ' + _crlf
 _result += '                                                                                     ' + _crlf
 _result += '* ----------------- Gentileza de Andrés González López " andyglezl " --------------* ' + _crlf
 _result += '   USE '+ mTable                                                                                                      + _crlf 
 _result += '	AEVAL( DBSTRUCT( "'+  mTable +'" ),;                                                                             ' + _crlf
 _result += '            { | aField | AADD( aCpos1, aField[ DBS_NAME ] ), AADD( aCpos2, "'+ mTable +'->"+ aField[ DBS_NAME ] ),; ' + _crlf
 _result += '                         AADD( aTips , aField[ DBS_TYPE ] ), AADD( aLong ,  aField[ DBS_LEN ] ), ;                  ' + _crlf
 _result += '                         AADD( aDec  , aField[ DBS_DEC ]  ) } )                                                     ' + _crlf
 _result += '        DBGoTop()                                                                    ' + _crlf
 _result += '                                                                                     ' + _crlf
 _result += '        nCpos := LEN( aCpos1 )                                                       ' + _crlf
 _result += '                                                                                     ' + _crlf
 _result += '	FOR i1 = 1 TO nCpos                                                               ' + _crlf
 _result += '                         IF aTips[ i1 ] = "N"                                        ' + _crlf    
 _result += '                             AADD( aColCtrls, { "TEXTBOX", "NUMERIC" } )             ' + _crlf 
 _result += '		     ELSEIF aTips[ i1 ] = "D"                                             ' + _crlf
 _result += '			     AADD( aColCtrls, { "DATEPICKER", "DROPDOWN" } )              ' + _crlf
 _result += '		     ELSEIF aTips[ i1 ] = "L"                                             ' + _crlf			
 _result += '			     AADD( aColCtrls, { "CHECKBOX" , "Yes" , "No" } )             ' + _crlf			
 _result += '		     ELSEIF aTips[ i1 ] = "C"                                             ' + _crlf			
 _result += '			     AADD( aColCtrls, { "TEXTBOX","CHARACTER" } )                 ' + _crlf
 _result += '                     ELSEIF aTips[ i1 ] = "M"	                                  ' + _crlf		
 _result += '			     AADD( aColCtrls, { "EDITBOX" } )                             ' + _crlf
 _result += '		         ENDIF                                                            ' + _crlf
 _result += '	NEXT                                                                              ' + _crlf
 _result += '*----------------------------------------------------------------------------------* ' + _crlf
 _result += '*----------------------------------  Grid -----------------------------------------* ' + _crlf
 _result += ' USE '+ mTable                        + _crlf
 _result += '                                    ' + _crlf
 _result += ' DEFINE GRID Grid_' + DNomZ           + _crlf       
 _result += '        ROW     ' +  DCurZRow         + _crlf         
 _result += '        COL     ' +  DCurZCol         + _crlf
 _result += '        WIDTH   ' +  DLasZWidth       + _crlf
 _result += '        HEIGHT  ' +  DLasZHeight      + _crlf
 _result += '        HEADERS  aFldnm             ' + _crlf    
 _result += '        WIDTHS   aWidth             ' + _crlf   
 _result += '        ITEMS { {""} }              ' + _crlf
 _result += '        VALUE Nil                   ' + _crlf
 _result += '        FONTNAME "Arial"            ' + _crlf
 _result += '        FONTSIZE 9                  ' + _crlf
 _result += '        TOOLTIP ""                  ' + _crlf
 _result += '        ONCHANGE Nil                ' + _crlf
 _result += '        ONGOTFOCUS Nil              ' + _crlf
 _result += '        ONLOSTFOCUS Nil             ' + _crlf
 _result += '        FONTBOLD .F.                ' + _crlf
 _result += '        FONTITALIC .F.              ' + _crlf
 _result += '        FONTUNDERLINE .F.           ' + _crlf
 _result += '        FONTSTRIKEOUT .F.           ' + _crlf
 _result += '        ONDBLCLICK Nil              ' + _crlf
 _result += '        ONHEADCLICK Nil             ' + _crlf
 _result += '        ONQUERYDATA Nil             ' + _crlf 
 _result += '        MULTISELECT .F.             ' + _crlf
 _result += '        ALLOWEDIT .T.               ' + _crlf
 _result += '        VIRTUAL .F.                 ' + _crlf
*---------------------------------------------------------------------------------------------* 
 IF win_grid.grid_19.Value = .T.
 _result += '        DYNAMICBACKCOLOR &(xbColor) ' + _crlf
 _result += '        DYNAMICFORECOLOR &(xfColor) ' + _crlf
 _result += '        BACKCOLOR { 180,200,255 }   ' + _crlf
 _result += '        FONTCOLOR Nil               ' + _crlf
ELSE
 _result += '        DYNAMICBACKCOLOR Nil        ' + _crlf
 _result += '        DYNAMICFORECOLOR Nil        ' + _crlf
 _result += '        BACKCOLOR Nil               ' + _crlf
 _result += '        FONTCOLOR Nil               ' + _crlf
ENDIF  
*---------------------------------------------------------------------------------------------* 
 _result += '        COLUMNWHEN Nil              ' + _crlf
 _result += '        COLUMNVALID Nil             ' + _crlf
 _result += '        COLUMNCONTROLS aColCtrls    ' + _crlf                       
 _result += '        SHOWHEADERS .T.             ' + _crlf
 _result += '        CELLNAVIGATION .F.          ' + _crlf
 _result += '        NOLINES .F.                 ' + _crlf
 _result += '        HELPID Nil                  ' + _crlf
 _result += '        IMAGE Nil                   ' + _crlf
 _result += '        JUSTIFY Nil                 ' + _crlf
 _result += '        ITEMCOUNT Nil               ' + _crlf
 _result += '        HEADERIMAGES Nil            ' + _crlf
 _result += '        ROWSOURCE mAlias            ' + _crlf
 _result += '        COLUMNFIELDS aFldnm         ' + _crlf
 _result += '        ALLOWAPPEND .T.             ' + _crlf
 _result += '        ALLOWDELETE .T.             ' + _crlf
 _result += '        BUFFERED .F.                ' + _crlf
 _result += '        DYNAMICDISPLAY Nil          ' + _crlf
 _result += '        ONSAVE Nil                  ' + _crlf
 _result += '        LOCKCOLUMNS Nil             ' + _crlf
 _result += ' END GRID                           ' + _crlf
 _result += '                                    ' + _crlf
*-----------------------------------------------------------------------------------------------*  
*-----------------------------------------------------------------------------------------------*
 _result += '  @ '+ ALLTRIM(STR(NumyZComant)) + ', 150 LABEL Grid_20 VALUE "  [Append (Alt+A)] [Delete (Alt+D)] [Recall (Alt+R)] [Save (Alt+S)] "'+;
                  ' WIDTH 358 HEIGHT 20 BOLD BACKCOLOR BLUE FONTCOLOR WHITE ' + _crlf
 _result += '                                       ' + _crlf
IF win_grid.grid_17.Value = .T.
 _result += '    DEFINE BUTTON But_01               ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight))   + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mCurZCol1) )    + _crlf  
 _result += '           WIDTH  028                  ' + _crlf
 _result += '           HEIGHT 028                  ' + _crlf
 _result += '           CAPTION "<<"                ' + _crlf
 _result += '           PICTURE ""                  ' + _crlf  
 _result += '           TOOLTIP "First"             ' + _crlf
 _result += '           ACTION ( dBGoTop() , '+ wName + '.Grid_'+ DNomZ+'.RecNo := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                         ' + _crlf

 _result += '                                       ' + _crlf
 _result += '    DEFINE BUTTON But_02               ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight))   + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mCurZCol2) )    + _crlf  
 _result += '           WIDTH  028                  ' + _crlf
 _result += '           HEIGHT 028                  ' + _crlf
 _result += '           CAPTION "<"                 ' + _crlf
 _result += '           PICTURE ""                  ' + _crlf  
 _result += '           TOOLTIP "Previous"          ' + _crlf
 _result += '           ACTION ( dBSkip ( -1 ) , '+ wName + '.Grid_'+ DNomZ+'.RecNo := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                         ' + _crlf
 _result += '                                       ' + _crlf

 _result += '    DEFINE BUTTON But_03               ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight))   + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mCurZCol3) )    + _crlf  
 _result += '           WIDTH  028                  ' + _crlf
 _result += '           HEIGHT 028                  ' + _crlf
 _result += '           CAPTION ">"                 ' + _crlf
 _result += '           PICTURE ""                  ' + _crlf  
 _result += '           TOOLTIP "Next"              ' + _crlf
 _result += '           ACTION ( dBSkip (1) , if ( Eof() , DbGoBottom() , Nil ) ,'+ wName + '.Grid_'+ DNomZ+'.RecNo := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                         ' + _crlf
 _result += '                                       ' + _crlf

 _result += '    DEFINE BUTTON But_04               ' + _crlf
 _result += '           ROW    ' + ALLTRIM(STR(NumyZHeight))   + _crlf        
 _result += '           COL    ' + ALLTRIM(STR(mCurZCol4) )    + _crlf  
 _result += '           WIDTH  028                  ' + _crlf
 _result += '           HEIGHT 028                  ' + _crlf
 _result += '           CAPTION ">>"                 ' + _crlf
 _result += '           PICTURE ""                  ' + _crlf  
 _result += '           TOOLTIP "Lastt"              ' + _crlf
 _result += '           ACTION ( dBGoBottom() , '+ wName + '.Grid_'+ DNomZ+'.RecNo := '+ alltrim( mTable) + '->(RecNo()) ) ' + _crlf   
 _result += '    END BUTTON                         ' + _crlf
 _result += '                                       ' + _crlf
ENDIF
 _result += '*-------------------------------------------------- Box  Grid ------------------------------------------* ' + _crlf
 _result += '    HMG_ChangeWindowStyle ( GetControlHandle("Grid_' + DNomZ +'","'+ wName +'") , LVS_REPORT, NIL, .T. )  ' + _crlf 
 _result += '*-------------------------------------------------------------------------------------------------------* ' + _crlf
 _result += '    FOR i = 1 TO GetProperty ("'+ wName +'","Grid_' + DNomZ +'","ColumnCount")                            ' + _crlf 
 _result += '        SetProperty ("'+ wName +'","Grid_' + DNomZ +'","ColumnWIDTH", i, GRID_WIDTH_AUTOSIZE)             ' + _crlf 
 _result += '    NEXT                                                                                                  ' + _crlf 
 _result += '*-------------------------------------------------------------------------------------------------------* ' + _crlf
 _result += '                                                                                                          ' + _crlf

 System.Clipboard := _result
 
 msginfo(_result)

Return  Nil 

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
